# ui
# creates the user interface

proc ui { } {

wm title . {TE No Tags}

frame .fr
frame .fr.mbar
pack .fr.mbar -side top -fill x


scrollbar .fr.yscroll -command {.fr.t yview}
text .fr.t -wrap word -width 80 -height 20 -bg white -yscrollcommand {.fr.yscroll set}
pack .fr -expand true -fill both
pack .fr.yscroll -side right -fill y
pack .fr.t -expand true -fill both

}


# initialize
# sets target text variable

proc initialize { } {

global targetText

set targetText [gettarget]

set noTags [tagstripper $targetText]

instarget $noTags

return

}



# gettarget
# opens target text script file and
# returns its content
# edit sFile for actual location of target.txt

proc gettarget { } {

global targetText

set sFile "target.txt"

set sFileHan [open $sFile r]

fconfigure $sFileHan -encoding utf-8

set segLen [file size $sFile]

set targetText [read $sFileHan $segLen]

close $sFileHan

return $targetText

}


# inserts text into UI text field

proc instarget {targetText} {

.fr.t delete 1.0 end

.fr.t insert 1.0 $targetText

}


# updatetarget
# retrieves target segment via gettarget
# inserts target segment in UI via instarget

# global targetText

proc updatetarget {oldTarget} {

set newTarget [gettarget]

if {$oldTarget == $newTarget} {

return

} else {

set noTags [tagstripper $newTarget]

instarget $noTags

	}

}


# listener
# every
# checks regularly for changes in target.txt
# (change in active OmegaT segment)

proc listener { } { 

global targetText

        every { updatetarget $targetText }    

}

proc every { command } {

global targetText

   eval $command

   after 500 [list every $command]

}


# tagstripper
# displays segment without tags
# accepts segment
# returns segment minus tags
# tag pattern not optimal

proc tagstripper {withTags} {

set tagpat {\<.+?\>}

regsub -all $tagpat $withTags {} noTags

return $noTags

}


ui

initialize

listener

