# ui
# creates the user interface

proc ui { } {

wm title . {TE Source Target No Tags}

frame .fr
frame .fr.mbar
pack .fr.mbar -side top -fill x


scrollbar .fr.yscroll -command {.fr.t yview}
text .fr.t -wrap word -width 80 -height 20 -bg white -yscrollcommand {.fr.yscroll set}
pack .fr -expand true -fill both
pack .fr.yscroll -side right -fill y
pack .fr.t -expand true -fill both

# For best results on your operating system, experiment with the 
# fonts, sizes and colours.
# stdfont is the standard font in the API window

.fr.t tag configure stdfont -font {Helvetica 14}

}


# initialize
# sets target text variable

proc initialize { } {

global sourceText
global targetText

set sourceText [getsource]

set targetText [gettarget]

set sNoTags [tagstripper $sourceText]

set tNoTags [tagstripper $targetText]

inssource $sNoTags

instarget $tNoTags

return

}



# getsource
# opens source text script file and
# returns its content
# edit sFile for actual location of source.txt

proc getsource { } {

global sourceText

set sFile "source.txt"

set sFileHan [open $sFile r]

fconfigure $sFileHan -encoding utf-8

set segLen [file size $sFile]

set sourceText [read $sFileHan $segLen]

close $sFileHan

return $sourceText

}


# gettarget
# opens target text script file and
# returns its content
# edit sFile for actual location of target.txt

proc gettarget { } {

global targetText

set sFile "target.txt"

set sFileHan [open $sFile r]

fconfigure $sFileHan -encoding utf-8

set segLen [file size $sFile]

set targetText [read $sFileHan $segLen]

close $sFileHan

return $targetText

}



# inserts source into UI text field

proc inssource {sourceText} {

.fr.t delete 1.0 end

.fr.t insert 1.0 $sourceText

.fr.t insert end "\n\n"

# .fr.t tag add stdfont 1.0 end

}


# inserts target into UI text field

proc instarget {targetText} {

.fr.t insert end $targetText

.fr.t tag add stdfont 1.0 end

}


# updatesource
# retrieves source segment via getsource
# inserts source segment in UI via inssource

proc updatesource {oldSource} {

set newSource [getsource]

if {$oldSource == $newSource} {

return

} else {

set noTags [tagstripper $newSource]

inssource $noTags

	}

}

# updatetarget
# retrieves target segment via gettarget
# inserts target segment in UI via instarget

# global targetText

proc updatetarget {oldTarget} {

set newTarget [gettarget]

if {$oldTarget == $newTarget} {

return

} else {

set noTags [tagstripper $newTarget]

instarget $noTags

	}

}




# listener
# every
# checks regularly for changes in target.txt
# (change in active OmegaT segment)

proc listener { } { 

global sourceText
global targetText

        every { updatesource $sourceText }    
        every { updatetarget $targetText }    

}

proc every { command } {

global sourceText
global targetText

   eval $command

   after 500 [list every $command]

}


# tagstripper
# displays segment without tags
# accepts segment
# returns segment minus tags
# tag pattern not optimal

proc tagstripper {withTags} {

set tagpat {\<.+?\>}

regsub -all $tagpat $withTags {} noTags

return $noTags

}


ui

initialize

listener

